#include "TCode.hpp"
#include "TCodeConfig.hpp"
#include "TCodeImplActuator.hpp"
#include "TCodeImplSensor.hpp"

namespace tcode::config {

const auto command_registry = mapbox::eternal::hash_map<CommandIndex, Command>({
     {{CommandType::Device, 0},
      Command(Command::delegate::create<identify_device>(),
              "Identify device and firmware version.")},
     {{CommandType::Device, 1},
      Command(Command::delegate::create<identify_protocol>(), "Identify [e]TCode version.")},
     {{CommandType::Device, 2},
      Command(Command::delegate::create<build_enumeration>(),
              "List available commands, axes, properties and other associated metadata.")},
     {{CommandType::Device, 3}, Command({}, "Global device configuration.")},
     {{CommandType::Device, 4},
      Command(Command::delegate::create<get_rtos_stats>(), "Interface with RTOS facilities.")},
     {{CommandType::Device, 5}, Command({}, "Actuator Config")},
     {{CommandType::Linear, 0}, Command({}, "Actuator #0")},
     {{CommandType::Rotate, 0}, Command({}, "Actuator #1")},
     {{CommandType::Rotate, 1}, Command({}, "Actuator #2")},
     {{CommandType::Vibrate, 0}, Command({}, "Aux #1")},
     {{CommandType::Vibrate, 1}, Command({}, "Aux #2")},
     {{CommandType::Auxiliary, 0}, Command({}, "Distance Sensor #0")},
});
const auto axis_registry = mapbox::eternal::hash_map<CommandIndex, AxisUpdate>({
     {{CommandType::Linear, 0},
      AxisUpdate(AxisUpdate::update_delegate::create<act0_normal_update>(),
                 AxisUpdate::update_interval_delegate::create<act0_interval_update>(), {},
                 AxisUpdate::stop_delegate::create<act0_stop>())},
     {{CommandType::Rotate, 0},
      AxisUpdate(AxisUpdate::update_delegate::create<act1_normal_update>(),
                 AxisUpdate::update_interval_delegate::create<act1_interval_update>(), {},
                 AxisUpdate::stop_delegate::create<act1_stop>())},
     {{CommandType::Rotate, 1},
      AxisUpdate(AxisUpdate::update_delegate::create<act2_normal_update>(),
                 AxisUpdate::update_interval_delegate::create<act2_interval_update>(), {},
                 AxisUpdate::stop_delegate::create<act2_stop>())},
     {{CommandType::Vibrate, 0},
      AxisUpdate(AxisUpdate::update_delegate::create<aux1_normal_update>(), {}, {},
                 AxisUpdate::stop_delegate::create<aux1_stop>())},
     {{CommandType::Vibrate, 1},
      AxisUpdate(AxisUpdate::update_delegate::create<aux2_normal_update>(), {}, {},
                 AxisUpdate::stop_delegate::create<aux2_stop>())},
     {{CommandType::Auxiliary, 0}, AxisUpdate({}, {}, {}, {})},
});

static constexpr auto TOGGLE_SW_FLAGS = Property::Flags(Property::FlagBits::Boolean) |
                                        Property::FlagBits::Event | Property::FlagBits::Action;
static constexpr auto TOGGLE_OPT_FLAGS =
     Property::Flags(Property::FlagBits::Boolean) | Property::FlagBits::Action;

const auto property_registry = mapbox::eternal::hash_map<PropertyKey, Property>({
     {PropertyKey(CommandType::Device, 0, "name"),
      Property(Property::Type::String, Property::getter_delegate::create<get_device_name>())},
     {PropertyKey(CommandType::Device, 0, "version"),
      Property(Property::Type::String,
               Property::getter_delegate::create<get_device_version>())},
     {PropertyKey(CommandType::Device, 0, "uuid"),
      Property(Property::Type::UBJson, Property::getter_delegate::create<get_device_uuid>())},

     {PropertyKey(CommandType::Device, 1, "name"),
      Property(Property::Type::String, Property::getter_delegate::create<get_protocol_name>())},
     {PropertyKey(CommandType::Device, 1, "version"),
      Property(Property::Type::String,
               Property::getter_delegate::create<get_protocol_version>())},

     {PropertyKey(CommandType::Device, 3, "save_count"),
      Property(Property::Type::UInt32,
               Property::getter_delegate::create<get_config_save_count>())},
     {PropertyKey(CommandType::Device, 3, "save"),
      Property(Property::Type::UInt32, TOGGLE_OPT_FLAGS, Property::DisplayType::PressButton,
               Property::getter_delegate{}, Property::setter_delegate::create<save_config>())},

     {PropertyKey(CommandType::Device, 4, "time"),
      Property(Property::Type::Int64, Property::getter_delegate::create<get_rtos_time>(),
               Property::setter_delegate::create<set_rtos_time>())},
     {PropertyKey(CommandType::Device, 4, "date"),
      Property(Property::Type::UBJson, Property::getter_delegate::create<get_rtos_date>())},
     {PropertyKey(CommandType::Device, 4, "log"),
      Property(Property::Type::String, Property::getter_delegate::create<get_log>())},

     {PropertyKey(CommandType::Device, 5, "pid_loop_status"),
      Property(Property::Type::UInt32, TOGGLE_SW_FLAGS,
               Property::getter_delegate::create<get_pid_loop_status>(),
               Property::setter_delegate::create<set_pid_loop_status>())},
     {PropertyKey(CommandType::Device, 5, "homing_enable"),
      Property(Property::Type::UInt32, TOGGLE_OPT_FLAGS,
               Property::getter_delegate::create<get_homing_enable>(),
               Property::setter_delegate::create<set_homing_enable>())},
     {PropertyKey(CommandType::Device, 5, "pid_tick_count"),
      Property(Property::Type::UInt32,
               Property::getter_delegate::create<get_pid_tick_count>())},
     {PropertyKey(CommandType::Device, 5, "pwm_prescaler"),
      Property(Property::Type::Int32, Property::getter_delegate::create<get_pwm_prescaler>(),
               Property::setter_delegate::create<set_pwm_prescaler>(),
               Property::append_metadata_delegate::create<meta_pwm_prescaler>())},
     {PropertyKey(CommandType::Device, 5, "aux_engaged"),
      Property(Property::Type::UInt32, TOGGLE_SW_FLAGS,
               Property::getter_delegate::create<aux_get_engaged>(),
               Property::setter_delegate::create<aux_set_engaged>())},
     {PropertyKey(CommandType::Device, 5, "plot_enable"),
      Property(Property::Type::UInt32, TOGGLE_OPT_FLAGS,
               Property::getter_delegate::create<get_plot_enable>(),
               Property::setter_delegate::create<set_plot_enable>())},

     {PropertyKey(CommandType::Linear, 0, "engaged"),
      Property(Property::Type::UInt32, TOGGLE_SW_FLAGS,
               Property::getter_delegate::create<act0_get_engaged>(),
               Property::setter_delegate::create<act0_set_engaged>())},
     {PropertyKey(CommandType::Linear, 0, "engaged_break"),
      Property(Property::Type::UInt32, TOGGLE_OPT_FLAGS,
               Property::getter_delegate::create<act0_get_engaged_break>(),
               Property::setter_delegate::create<act0_set_engaged_break>())},
     {PropertyKey(CommandType::Linear, 0, "raw_pos"),
      Property(Property::Type::UInt32, Property::getter_delegate::create<act0_get_raw_pos>(),
               {}, Property::append_metadata_delegate::create<update_interval_meta_500>())},
     {PropertyKey(CommandType::Linear, 0, "scaled_pos"),
      Property(Property::Type::FP32, Property::getter_delegate::create<act0_get_scaled_pos>(),
               {},
               Property::append_metadata_delegate::create<update_interval_meta_500_norm>())},
     {PropertyKey(CommandType::Linear, 0, "homing_speed"),
      Property(Property::Type::FP32, Property::getter_delegate::create<act0_get_homing_speed>(),
               Property::setter_delegate::create<act0_set_homing_speed>(),
               Property::append_metadata_delegate::create<meta_homing_speed>())},
     {PropertyKey(CommandType::Linear, 0, "tune_pid_kp"),
      Property(Property::Type::FP32, Property::DisplayType::DragBox,
               Property::getter_delegate::create<act0_get_tune_pid_kp>(),
               Property::setter_delegate::create<act0_set_tune_pid_kp>(),
               Property::append_metadata_delegate::create<meta_tune_pid_kp>())},
     {PropertyKey(CommandType::Linear, 0, "tune_pid_ki"),
      Property(Property::Type::FP32, Property::DisplayType::DragBox,
               Property::getter_delegate::create<act0_get_tune_pid_ki>(),
               Property::setter_delegate::create<act0_set_tune_pid_ki>(),
               Property::append_metadata_delegate::create<meta_tune_pid_ki>())},
     {PropertyKey(CommandType::Linear, 0, "tune_pid_kd"),
      Property(Property::Type::FP32, Property::DisplayType::DragBox,
               Property::getter_delegate::create<act0_get_tune_pid_kd>(),
               Property::setter_delegate::create<act0_set_tune_pid_kd>(),
               Property::append_metadata_delegate::create<meta_tune_pid_kd>())},
     {PropertyKey(CommandType::Linear, 0, "tune_pid_bias"),
      Property(Property::Type::FP32, Property::DisplayType::DragBox,
               Property::getter_delegate::create<act0_get_tune_pid_bias>(),
               Property::setter_delegate::create<act0_set_tune_pid_bias>(),
               Property::append_metadata_delegate::create<meta_tune_pid_bias>())},
     {PropertyKey(CommandType::Linear, 0, "tune_pwm_deadband"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<act0_get_tune_pwm_deadband>(),
               Property::setter_delegate::create<act0_set_tune_pwm_deadband>(),
               Property::append_metadata_delegate::create<meta_tune_pwm_deadband>())},
     {PropertyKey(CommandType::Linear, 0, "axis_limit_min"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<act0_get_axis_limit_min>(),
               Property::setter_delegate::create<act0_set_axis_limit_min>(),
               Property::append_metadata_delegate::create<meta_axis_limit_min>())},
     {PropertyKey(CommandType::Linear, 0, "axis_limit_max"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<act0_get_axis_limit_max>(),
               Property::setter_delegate::create<act0_set_axis_limit_max>(),
               Property::append_metadata_delegate::create<meta_axis_limit_max>())},
     {PropertyKey(CommandType::Linear, 0, "plot"),
      Property(Property::Type::UBJson,
               Property::Flags(Property::FlagBits::Observations) | Property::FlagBits::Event,
               Property::DisplayType::Plot, Property::getter_delegate::create<get_act0_plot>(),
               {}, Property::append_metadata_delegate::create<meta_act_plot>())},

     {PropertyKey(CommandType::Rotate, 0, "engaged"),
      Property(Property::Type::UInt32, TOGGLE_SW_FLAGS,
               Property::getter_delegate::create<act1_get_engaged>(),
               Property::setter_delegate::create<act1_set_engaged>())},
     {PropertyKey(CommandType::Rotate, 0, "engaged_break"),
      Property(Property::Type::UInt32, TOGGLE_OPT_FLAGS,
               Property::getter_delegate::create<act1_get_engaged_break>(),
               Property::setter_delegate::create<act1_set_engaged_break>())},
     {PropertyKey(CommandType::Rotate, 0, "raw_pos"),
      Property(Property::Type::UBJson, Property::getter_delegate::create<act1_get_raw_pos>(),
               {}, Property::append_metadata_delegate::create<update_interval_meta_500>())},
     {PropertyKey(CommandType::Rotate, 0, "scaled_pos"),
      Property(Property::Type::FP32, Property::getter_delegate::create<act1_get_scaled_pos>(),
               {},
               Property::append_metadata_delegate::create<update_interval_meta_500_norm>())},
     {PropertyKey(CommandType::Rotate, 0, "homing_speed"),
      Property(Property::Type::FP32, Property::getter_delegate::create<act1_get_homing_speed>(),
               Property::setter_delegate::create<act1_set_homing_speed>(),
               Property::append_metadata_delegate::create<meta_homing_speed>())},
     {PropertyKey(CommandType::Rotate, 0, "tune_pid_kp"),
      Property(Property::Type::FP32, Property::DisplayType::DragBox,
               Property::getter_delegate::create<act1_get_tune_pid_kp>(),
               Property::setter_delegate::create<act1_set_tune_pid_kp>(),
               Property::append_metadata_delegate::create<meta_tune_pid_kp>())},
     {PropertyKey(CommandType::Rotate, 0, "tune_pid_ki"),
      Property(Property::Type::FP32, Property::DisplayType::DragBox,
               Property::getter_delegate::create<act1_get_tune_pid_ki>(),
               Property::setter_delegate::create<act1_set_tune_pid_ki>(),
               Property::append_metadata_delegate::create<meta_tune_pid_ki>())},
     {PropertyKey(CommandType::Rotate, 0, "tune_pid_kd"),
      Property(Property::Type::FP32, Property::DisplayType::DragBox,
               Property::getter_delegate::create<act1_get_tune_pid_kd>(),
               Property::setter_delegate::create<act1_set_tune_pid_kd>(),
               Property::append_metadata_delegate::create<meta_tune_pid_kd>())},
     {PropertyKey(CommandType::Rotate, 0, "tune_pid_bias"),
      Property(Property::Type::FP32, Property::DisplayType::DragBox,
               Property::getter_delegate::create<act1_get_tune_pid_bias>(),
               Property::setter_delegate::create<act1_set_tune_pid_bias>(),
               Property::append_metadata_delegate::create<meta_tune_pid_bias>())},
     {PropertyKey(CommandType::Rotate, 0, "tune_pwm_deadband"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<act1_get_tune_pwm_deadband>(),
               Property::setter_delegate::create<act1_set_tune_pwm_deadband>(),
               Property::append_metadata_delegate::create<meta_tune_pwm_deadband>())},
     {PropertyKey(CommandType::Rotate, 0, "axis_limit_min"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<act1_get_axis_limit_min>(),
               Property::setter_delegate::create<act1_set_axis_limit_min>(),
               Property::append_metadata_delegate::create<meta_axis_limit_min>())},
     {PropertyKey(CommandType::Rotate, 0, "axis_limit_max"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<act1_get_axis_limit_max>(),
               Property::setter_delegate::create<act1_set_axis_limit_max>(),
               Property::append_metadata_delegate::create<meta_axis_limit_max>())},
     {PropertyKey(CommandType::Rotate, 0, "plot"),
      Property(Property::Type::UBJson,
               Property::Flags(Property::FlagBits::Observations) | Property::FlagBits::Event,
               Property::DisplayType::Plot, Property::getter_delegate::create<get_act1_plot>(),
               {}, Property::append_metadata_delegate::create<meta_act_plot>())},

     {PropertyKey(CommandType::Rotate, 1, "engaged"),
      Property(Property::Type::UInt32, TOGGLE_SW_FLAGS,
               Property::getter_delegate::create<act2_get_engaged>(),
               Property::setter_delegate::create<act2_set_engaged>())},
     {PropertyKey(CommandType::Rotate, 1, "engaged_break"),
      Property(Property::Type::UInt32, TOGGLE_OPT_FLAGS,
               Property::getter_delegate::create<act2_get_engaged_break>(),
               Property::setter_delegate::create<act2_set_engaged_break>())},
     {PropertyKey(CommandType::Rotate, 1, "raw_pos"),
      Property(Property::Type::UBJson, Property::getter_delegate::create<act2_get_raw_pos>(),
               {}, Property::append_metadata_delegate::create<update_interval_meta_500>())},
     {PropertyKey(CommandType::Rotate, 1, "scaled_pos"),
      Property(Property::Type::FP32, Property::getter_delegate::create<act2_get_scaled_pos>(),
               {},
               Property::append_metadata_delegate::create<update_interval_meta_500_norm>())},
     {PropertyKey(CommandType::Rotate, 1, "homing_speed"),
      Property(Property::Type::FP32, Property::getter_delegate::create<act2_get_homing_speed>(),
               Property::setter_delegate::create<act2_set_homing_speed>(),
               Property::append_metadata_delegate::create<meta_homing_speed>())},
     {PropertyKey(CommandType::Rotate, 1, "tune_pid_kp"),
      Property(Property::Type::FP32, Property::DisplayType::DragBox,
               Property::getter_delegate::create<act2_get_tune_pid_kp>(),
               Property::setter_delegate::create<act2_set_tune_pid_kp>(),
               Property::append_metadata_delegate::create<meta_tune_pid_kp>())},
     {PropertyKey(CommandType::Rotate, 1, "tune_pid_ki"),
      Property(Property::Type::FP32, Property::DisplayType::DragBox,
               Property::getter_delegate::create<act2_get_tune_pid_ki>(),
               Property::setter_delegate::create<act2_set_tune_pid_ki>(),
               Property::append_metadata_delegate::create<meta_tune_pid_ki>())},
     {PropertyKey(CommandType::Rotate, 1, "tune_pid_kd"),
      Property(Property::Type::FP32, Property::DisplayType::DragBox,
               Property::getter_delegate::create<act2_get_tune_pid_kd>(),
               Property::setter_delegate::create<act2_set_tune_pid_kd>(),
               Property::append_metadata_delegate::create<meta_tune_pid_kd>())},
     {PropertyKey(CommandType::Rotate, 1, "tune_pid_bias"),
      Property(Property::Type::FP32, Property::DisplayType::DragBox,
               Property::getter_delegate::create<act2_get_tune_pid_bias>(),
               Property::setter_delegate::create<act2_set_tune_pid_bias>(),
               Property::append_metadata_delegate::create<meta_tune_pid_bias>())},
     {PropertyKey(CommandType::Rotate, 1, "tune_pwm_deadband"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<act2_get_tune_pwm_deadband>(),
               Property::setter_delegate::create<act2_set_tune_pwm_deadband>(),
               Property::append_metadata_delegate::create<meta_tune_pwm_deadband>())},
     {PropertyKey(CommandType::Rotate, 1, "axis_limit_min"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<act2_get_axis_limit_min>(),
               Property::setter_delegate::create<act2_set_axis_limit_min>(),
               Property::append_metadata_delegate::create<meta_axis_limit_min>())},
     {PropertyKey(CommandType::Rotate, 1, "axis_limit_max"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<act2_get_axis_limit_max>(),
               Property::setter_delegate::create<act2_set_axis_limit_max>(),
               Property::append_metadata_delegate::create<meta_axis_limit_max>())},
     {PropertyKey(CommandType::Rotate, 1, "plot"),
      Property(Property::Type::UBJson,
               Property::Flags(Property::FlagBits::Observations) | Property::FlagBits::Event,
               Property::DisplayType::Plot, Property::getter_delegate::create<get_act2_plot>(),
               {}, Property::append_metadata_delegate::create<meta_act_plot>())},

     {PropertyKey(CommandType::Vibrate, 0, "tune_pwm_deadband"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<aux1_get_tune_pwm_deadband>(),
               Property::setter_delegate::create<aux1_set_tune_pwm_deadband>(),
               Property::append_metadata_delegate::create<meta_tune_pwm_deadband>())},
     {PropertyKey(CommandType::Vibrate, 0, "tune_pwm_bias"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<aux1_get_tune_pwm_bias>(),
               Property::setter_delegate::create<aux1_set_tune_pwm_bias>(),
               Property::append_metadata_delegate::create<meta_tune_pwm_bias>())},
     {PropertyKey(CommandType::Vibrate, 0, "axis_limit_min"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<aux1_get_axis_limit_min>(),
               Property::setter_delegate::create<aux1_set_axis_limit_min>(),
               Property::append_metadata_delegate::create<meta_axis_limit_min>())},
     {PropertyKey(CommandType::Vibrate, 0, "axis_limit_max"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<aux1_get_axis_limit_max>(),
               Property::setter_delegate::create<aux1_set_axis_limit_max>(),
               Property::append_metadata_delegate::create<meta_axis_limit_max>())},

     {PropertyKey(CommandType::Vibrate, 1, "tune_pwm_deadband"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<aux2_get_tune_pwm_deadband>(),
               Property::setter_delegate::create<aux2_set_tune_pwm_deadband>(),
               Property::append_metadata_delegate::create<meta_tune_pwm_deadband>())},
     {PropertyKey(CommandType::Vibrate, 1, "tune_pwm_bias"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<aux2_get_tune_pwm_bias>(),
               Property::setter_delegate::create<aux2_set_tune_pwm_bias>(),
               Property::append_metadata_delegate::create<meta_tune_pwm_bias>())},
     {PropertyKey(CommandType::Vibrate, 1, "axis_limit_min"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<aux2_get_axis_limit_min>(),
               Property::setter_delegate::create<aux2_set_axis_limit_min>(),
               Property::append_metadata_delegate::create<meta_axis_limit_min>())},
     {PropertyKey(CommandType::Vibrate, 1, "axis_limit_max"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<aux2_get_axis_limit_max>(),
               Property::setter_delegate::create<aux2_set_axis_limit_max>(),
               Property::append_metadata_delegate::create<meta_axis_limit_max>())},

     {PropertyKey(CommandType::Auxiliary, 0, "is_scanning"),
      Property(Property::Type::UInt32, TOGGLE_OPT_FLAGS,
               Property::getter_delegate::create<sonar_get_is_scanning>(),
               Property::setter_delegate::create<sonar_set_is_scanning>())},
     {PropertyKey(CommandType::Auxiliary, 0, "raw_measurement"),
      Property(Property::Type::UInt32,
               Property::getter_delegate::create<sonar_get_raw_measurement>(), {},
               Property::append_metadata_delegate::create<update_interval_meta_500>())},
     {PropertyKey(CommandType::Auxiliary, 0, "measurement_errors"),
      Property(Property::Type::UInt32,
               Property::getter_delegate::create<sonar_get_measurement_errors>(), {},
               Property::append_metadata_delegate::create<update_interval_meta_500>())},
     {PropertyKey(CommandType::Auxiliary, 0, "scaled_measurement"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<sonar_get_scaled_measurement>(), {},
               Property::append_metadata_delegate::create<update_interval_meta_500>())},
     {PropertyKey(CommandType::Auxiliary, 0, "filtered_measurement"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<sonar_get_filtered_measurement>(), {},
               Property::append_metadata_delegate::create<update_interval_meta_500>())},
     {PropertyKey(CommandType::Auxiliary, 0, "normalized_measurement"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<sonar_get_normalized_measurement>(), {},
               Property::append_metadata_delegate::create<update_interval_meta_500_norm>())},
     {PropertyKey(CommandType::Auxiliary, 0, "norm_near"),
      Property(Property::Type::FP32, Property::getter_delegate::create<sonar_get_norm_near>(),
               Property::setter_delegate::create<sonar_set_norm_near>(),
               Property::append_metadata_delegate::create<meta_sonar_config_fullscale>())},
     {PropertyKey(CommandType::Auxiliary, 0, "norm_far"),
      Property(Property::Type::FP32, Property::getter_delegate::create<sonar_get_norm_far>(),
               Property::setter_delegate::create<sonar_set_norm_far>(),
               Property::append_metadata_delegate::create<meta_sonar_config_fullscale>())},
     {PropertyKey(CommandType::Auxiliary, 0, "norm_invert"),
      Property(Property::Type::UInt32, TOGGLE_OPT_FLAGS,
               Property::getter_delegate::create<sonar_get_norm_invert>(),
               Property::setter_delegate::create<sonar_set_norm_invert>())},
     {PropertyKey(CommandType::Auxiliary, 0, "threshold1"),
      Property(Property::Type::FP32, Property::getter_delegate::create<sonar_get_threshold1>(),
               Property::setter_delegate::create<sonar_set_threshold1>(),
               Property::append_metadata_delegate::create<meta_sonar_config_normalized>())},
     {PropertyKey(CommandType::Auxiliary, 0, "threshold2"),
      Property(Property::Type::FP32, Property::getter_delegate::create<sonar_get_threshold2>(),
               Property::setter_delegate::create<sonar_set_threshold2>(),
               Property::append_metadata_delegate::create<meta_sonar_config_normalized>())},
     {PropertyKey(CommandType::Auxiliary, 0, "threshold_selector"),
      Property(Property::Type::FP32,
               Property::getter_delegate::create<sonar_get_threshold_selector>(),
               Property::setter_delegate::create<sonar_set_threshold_selector>(),
               Property::append_metadata_delegate::create<meta_sonar_config_normalized>())},
     {PropertyKey(CommandType::Auxiliary, 0, "alpha1"),
      Property(Property::Type::FP32, Property::getter_delegate::create<sonar_get_alpha1>(),
               Property::setter_delegate::create<sonar_set_alpha1>(),
               Property::append_metadata_delegate::create<meta_sonar_config_normalized>())},
     {PropertyKey(CommandType::Auxiliary, 0, "alpha2"),
      Property(Property::Type::FP32, Property::getter_delegate::create<sonar_get_alpha2>(),
               Property::setter_delegate::create<sonar_set_alpha2>(),
               Property::append_metadata_delegate::create<meta_sonar_config_normalized>())},
     {PropertyKey(CommandType::Auxiliary, 0, "reset_filter"),
      Property(Property::Type::UInt32, TOGGLE_OPT_FLAGS, Property::DisplayType::PressButton,
               Property::getter_delegate{},
               Property::setter_delegate::create<sonar_reset_filter>())},
     {PropertyKey(CommandType::Auxiliary, 0, "plot"),
      Property(Property::Type::UBJson,
               Property::Flags(Property::FlagBits::Observations) | Property::FlagBits::Event,
               Property::DisplayType::Plot, Property::getter_delegate::create<sonar_get_plot>(),
               {}, Property::append_metadata_delegate::create<meta_sonar_plot>())},
});

const Property& event_meta_pid_loop_status =
     property_registry.at(PropertyKey(CommandType::Device, 5, "pid_loop_status"))->second;
const Property& event_meta_act0_engaged =
     property_registry.at(PropertyKey(CommandType::Linear, 0, "engaged"))->second;
const Property& event_meta_act1_engaged =
     property_registry.at(PropertyKey(CommandType::Rotate, 0, "engaged"))->second;
const Property& event_meta_act2_engaged =
     property_registry.at(PropertyKey(CommandType::Rotate, 1, "engaged"))->second;
const Property& event_meta_aux_engaged =
     property_registry.at(PropertyKey(CommandType::Device, 5, "aux_engaged"))->second;
const Property& event_meta_act0_plot =
     property_registry.at(PropertyKey(CommandType::Linear, 0, "plot"))->second;
const Property& event_meta_act1_plot =
     property_registry.at(PropertyKey(CommandType::Rotate, 0, "plot"))->second;
const Property& event_meta_act2_plot =
     property_registry.at(PropertyKey(CommandType::Rotate, 1, "plot"))->second;
const Property& event_meta_sonar_plot =
     property_registry.at(PropertyKey(CommandType::Auxiliary, 0, "plot"))->second;

}  // namespace tcode::config
